<script setup lang="ts">
  const DEBOUNCE_SEARCH_TIME = 1000; // ms

  const emits = defineEmits<{
    (e: 'change', input?: string): void;
  }>();

  const props = withDefaults(
    defineProps<{
      value?: string;
      debounceTime?: number;
    }>(),
    {
      value: '',
      debounceTime: DEBOUNCE_SEARCH_TIME,
    },
  );
  const propsValue = computed(() => props.value);
  const keyword = ref('');
  syncRefs(propsValue, keyword);

  const onKeywordChanged = (e: Event) => {
    keyword.value = (e.target as any)?.value || '';
    searchDebounced();
  };

  const searchDebounced = useDebounceFn(() => {
    emits('change', keyword.value.trim());
  }, props.debounceTime);
</script>

<template>
  <div
    class="rounded-2 border-information-disabled shadow-1 flex w-full items-center border bg-white px-2 py-1"
  >
    <span class="i-sw-solid:search color-information" />
    <input
      type="text"
      class="text-information-subdued ml-1 flex-1 border-none bg-transparent p-0 text-sm focus:outline-none"
      placeholder="Search"
      :value="keyword"
      @input="onKeywordChanged"
    />
  </div>
</template>

<style scoped>
  input {
    &:focus {
      box-shadow: none !important;
    }
  }
</style>
